=== debian/changelog ===
sortmerna (4.3.7-3) unstable; urgency=medium

  * c23.patch: new: fix build failure with bool redefinition. (Closes: #1097910)
  * d/watch: port to v5 Github template.
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundant Rules-Requires-Root: no.
  * concurrentqueue.h.patch: normalize Last-Update.
  * d/copyright: point to the versioned LGPL-3.

 -- Étienne Mollier <emollier@debian.org>  Sun, 05 Oct 2025 23:01:51 +0200

sortmerna (4.3.7-2) unstable; urgency=medium

  * Fix Python3.12 string syntax
    Closes: #1087092
  * d/copyright: Fixes thanks to lrc

 -- Andreas Tille <tille@debian.org>  Wed, 11 Dec 2024 17:38:13 +0100

sortmerna (4.3.7-1) unstable; urgency=medium

  * New upstream version 4.3.7
  * cmake_RocksDB.patch: delete: patch now irrelevant.
  * rapidjson.patch: delete: patch now irrelevant.
  * no_static_linking.patch: delete: affected hunk disappeared upstream.
  * typos.patch: delete: affected hunks disappeared upstream.
  * d/{control,rules}: migrate to pybuild and dh-sequence-python3.
  * d/tests/: bring back superficial verifications.
    The way of using sortmerna changed over time, but the test suite
    proposed for autopkgtest needs involved adjustments.  Most of the
    meat of the script is currently skipped, to only verify version and
    usage information can be shown to end users.  Not ideal, but better
    than no tests at all.
  * d/{watch,u/metadata}: adjust to github redirection.
  * d/control: point the homepage to the github project.
    The original homepage on Université de Lille website does not look to
    be available anymore.
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Sat, 01 Jun 2024 14:27:59 +0200

sortmerna (4.3.6-3) unstable; urgency=medium

  * d/rules: convert example files to Unicode per lintian flag.
  * typos.patch: add; fix typos caught by lintian.
  * d/copyright: update copyright year.
  * concurrentqueue.h.patch: update concurrentqueue.h location.
    (Closes: #1051325)
  * gcc-13.patch: new: fix ftbfs with gcc-13.

 -- Étienne Mollier <emollier@debian.org>  Wed, 06 Sep 2023 19:43:10 +0200
