=== debian/control ===
Source: sortmerna
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               python3-all,
               cmake,
               librocksdb-dev (>= 6.25.3),
               libgflags-dev,
               libsnappy-dev,
               libzstd-dev,
               rapidjson-dev,
               libconcurrentqueue-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/sortmerna
Vcs-Git: https://salsa.debian.org/med-team/sortmerna.git
Homepage: https://github.com/sortmerna/sortmerna

Package: sortmerna
Architecture: any-amd64 any-i386 x32
Depends: ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends},
         sse2-support [any-i386]
Description: tool for filtering, mapping and OTU-picking NGS reads
 SortMeRNA is a biological sequence analysis tool for filtering, mapping and
 OTU-picking NGS reads. The core algorithm is based on approximate seeds and
 allows for fast and sensitive analyses of nucleotide sequences. The main
 application of SortMeRNA is filtering rRNA from metatranscriptomic data.
 Additional applications include OTU-picking and taxonomy assignation available
 through QIIME v1.9+ (http://qiime.org - v1.9.0-rc1).
 SortMeRNA takes as input a file of reads (fasta or fastq format) and one or
 multiple rRNA database file(s), and sorts apart rRNA and rejected reads into
 two files specified by the user. Optionally, it can provide high quality local
 alignments of rRNA reads against the rRNA database. SortMeRNA works with
 Illumina, 454, Ion Torrent and PacBio data, and can produce SAM and
 BLAST-like alignments.
