=== debian/watch ===
Version: 5

Template: Github
Owner: sortmerna
Project: sortmerna
UVersion-Mangle: s/-beta/~beta/
